; sends data from ADC to USART

.arch atmega8
; 1 MHz

.equ int12, 1
.equ int13, 1
.equ int15, 1

.include "m8def.inc"
.include "macros.inc"
.include "init.inc"
.include "ints.inc"

.include "adc.inc"
.include "sleep.inc"
.include "usart.inc"
.include "ports.inc"

CODE_START:
 INIT_STACK
 INIT_WD    WD_TIMEOUT_1s

    malloc(  last_adc,1)    ; r21
    malloc(  last_sent,1)   ; r22
    malloc(  do_send,1)     ; r20

    ldi     r16, 0
    sts     last_adc, r16
    sts     last_sent, r16
    ldi     r16, 1
    sts     do_send, r16

    call0   CLEAR_PB6
    call0   USART_INT_INIT
    call0   ADC_INT_INIT
    
    call2   SLEEP, 0, 200
    call0   SET_PB6

    ldi r23, 1
loop1:
    wdr
    sei
    sleep
    
    rjmp    loop1

CODE_INT12:  ; usart rxc
    wdr
    in      r16, UDR
    ; if recv'd digit ('0'..'9','a'..'z','A'..'Z')
    ; check only upper bytes
    
    ;TODO: values[last_adc] += (rcv>>7)
    reti

CODE_INT13:  ; usart udre
    wdr

    inc     r23
;   breq    fsend   ;; force send after 256 cycles
   
    cp      r21, r22
    breq    skipsend 
fsend:
    out     UDR, r21

    call0   CLEAR_PB6
    
    mov     r22, r21
    ldi     r20, 0
    rjmp    i13end

skipsend:
    ldi r16, '-'
    out     UDR, r16

i13end:

    reti
 
CODE_INT15:  ; ADC
    wdr
    in      r21, ADCH

    reti

