; 1 MHz

; ARGS: -
; destroyed: up to r17
PROC USART_INIT

	LDI r16, 25	;  25 = 2400baud ; 12 = 4800baud
	OUT UBRRL, r16
	LDI r16, 0
	OUT UBRRH, r16	

	LDI r16, (1<<RXEN) | (1<<TXEN)    ; enable txd, rxd
	OUT UCSRB, r16

    ; select format (8bit, 1stop, even parity)
    ; URSEL = 1 ; UCSRC register
    ; UMSEL = 0 ; async transfer
    ; UPMx = 10  ; even parity
    ; USBS = 0 ; 1 stop bit
    ; UCSZx = 0x3 ; 8bit
    ldi     r16, (1<<URSEL)|(1<<UPM1)|(0<<UPM0)|(0x3<<UCSZ0) 
    out     UCSRC, r16

ENDPROC

; initialize USART with interrupts
PROC USART_INT_INIT
	LDI r16, 25
	OUT UBRRL, r16
	LDI r16, 0
	OUT UBRRH, r16	
	LDI	r16, (1<<TXCIE)|(1<<RXCIE)|(1<<UDRIE)|(1<<RXEN)|(1<<TXEN)
	OUT	UCSRB, r16
    ldi	r16, (1<<URSEL)|(1<<UPM1)|(0<<UPM0)|(0x3<<UCSZ0) 
    out	UCSRC, r16
ENDPROC

; ARGS: tx_byte
; destroyed: r16
PROC USART_SEND
    pop     r16
USART_001:
    sbis    UCSRA, UDRE
    rjmp    USART_001

    out     UDR, r16

ENDPROC

; ARGS: -
; return value: received byte (r16), error if carry set
; destroyed: r16

PROC USART_RECV
	rjmp	USART_017

PROC USART_RECV_WAIT
USART_019:
    sbis    UCSRA, RXC ; wait ?? this flag is cleared by USART_SEND_READY
    rjmp    USART_019

USART_017:
    in      r17, UCSRA
    in      r16, UDR
    andi    r17, (1<<FE)|(1<<DOR)|(1<<PE) ; frame&parity error & data overflow
    breq    USART_020
    sec
    rjmp    USART_021
USART_020:   ; no error
    clc
USART_021:

ENDPROC

; ARGS: -
; return value: carry set if buffer is empty
; destroyed: -
PROC USART_SEND_READY
    sec
    sbis    UCSRA, UDRE
    clc
ENDPROC

; ARGS: -
; return value: carry set if data in buffer
; destroyed: -
PROC USART_RECV_READY
    sec
    sbis    UCSRA, RXC  ; RXC = receive complete
    clc
ENDPROC

