import java.util.regex.*;
import pmp.*;

/**
 * Macro that creates user-defined macro.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Heredoc extends AbstractMacro {

    public static final int PARAMS_REQUIRED = 0;

    private Matcher heredoc = Pattern.compile("\\<\\<\\<([^\r\n]+)").matcher("");

    @Override
    public String run(Macroprocessor mp, String[] args)
    {
        MacroList ml = mp.getMPMacros();
        heredoc.reset(args[0]);
        if (heredoc.matches()) {
            String sep = heredoc.group(1);
            ml.setMacro("pmp:string.heredoc.mode", "copy");
            ml.setMacro("pmp:string.heredoc.marks-mode", "copy");
            ml.setMacro("pmp:string.heredoc.standalone", "true");
            ml.setMacro("pmp:string.heredoc.start", "<<<" + sep);
            ml.setMacro("pmp:string.heredoc.end", "\n" + sep + ";?\r?\n");
            return args[0];
        }

        mp.warning("Macro Heredoc: unexpected call");
        return "";
    }

}
