package pmp;

/**
 * Signals fatal error in macroprocessor.
 * <p>This exception is raised by {@link InputOutput#errorHandler(String)}
 * and various other places in macroprocessor when it's necessary to terminate
 * work.</p>
 * <p>Title: PMP: Macroprocessor</p>
 * <p>Description: Java macroprocessor</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class FatalParserException
    extends RuntimeException {

  /**
   * Creates exception with specified message.
   * @param message error description
   */
  public FatalParserException(String message)
  {
    super(message);
  }

  /** this is only to get rid of compiler warnings   */
  private static final long serialVersionUID = -1L;
}
