package pmp;

/**
 * Version info for PMP.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * <b>History</b>
 * <p>
 * 2006-05-24 / 0.9.5.45 - moved to CVS <code></code>
 * </p>
 *
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 * 
 */

public final class Version extends AbstractMacro {

   /**
    * Location of CVS repository.
    */
   public static final String CVS_ROOT = ":extssh:hlavl1am@u-pl37.ms.mff.cuni.cz:/afs/ms/u/h/hlavl1am/cvs";

   /**
    * CVS Id of this file.
    */
   public static final String CVS_ID = "$Id: Version.java,v 1.11 2006/06/02 18:41:16 hlavl1am Exp $";

   /**
    * Revision number of this file.
    */
   public static final String CVS_REVISION = "$Revision: 1.11 $";

   /**
    * Date of last commit.
    */
   public static final String CVS_DATE = "$Date: 2006/06/02 18:41:16 $";

   /**
    * Last user who commited this file.
    */
   public static final String CVS_AUTHOR = "$Author: hlavl1am $";

   /**
    * CVS tag name.
    */
   public static final String CVS_NAME = "$Name:  $";

   /**
    * Full path to this source file in repository.
    */
   public static final String CVS_SOURCE = "$Source: /afs/ms/u/h/hlavl1am/cvs/pmp/src/pmp/Version.java,v $";

   /**
    * Name of this source file in repository.
    */
   public static final String CVS_RCSFILE = "$RCSfile: Version.java,v $";

   /**
    * Current version number.
    */
   public static final String VERSION = "0.9.5.50";

   /**
    * Last modified date.
    */
   public static final String LAST_MODIFIED = "2006-08-09";

   /**
    * Name of this project.
    */
   public static final String PROJECT_NAME = "PMP: Macroprocessor";

   /**
    * Author of this project.
    */
   public static final String AUTHOR = "Lud\u011Bk Hlav\u00E1\u010Dek";

   /**
    * Version of config files this build uses.
    */
   public static final String XMLCONFIG_VERSION = "0.95";


   @Override
   public String toString()
   {
      return VERSION;
   }
   
   public static final int PARAMS_REQUIRED = 1;

   @Override
   public String run(Macroprocessor mp, String[] args)
   {
      String arg1 = args[1].trim().toUpperCase();

      if (arg1.length() == 0) {
         return VERSION;
      }

      if ("XMLCONFIG_VERSION".equals(arg1)) {
         return XMLCONFIG_VERSION;
      } else if ("AUTHOR".equals(arg1)) {
         return AUTHOR;
      } else if ("VERSION".equals(arg1)) {
         return VERSION;
      } else if ("PROJECT_NAME".equals(arg1)) {
         return PROJECT_NAME;
      } else if ("LAST_MODIFIED".equals(arg1)) {
         return LAST_MODIFIED;
      }

      else if ("CVS_ROOT".equals(arg1)) {
         return CVS_ROOT;
      } else if ("CVS_ID".equals(arg1)) {
         return CVS_ID;
      } else if ("CVS_REVISION".equals(arg1)) {
         return CVS_REVISION;
      } else if ("CVS_DATE".equals(arg1)) {
         return CVS_DATE;
      } else if ("CVS_AUTHOR".equals(arg1)) {
         return CVS_AUTHOR;
      } else if ("CVS_NAME".equals(arg1)) {
         return CVS_NAME;
      } else if ("CVS_SOURCE".equals(arg1)) {
         return CVS_SOURCE;
      } else if ("CVS_RCSFILE".equals(arg1)) {
         return CVS_RCSFILE;
      }

      mp.warning("Macro Version: Unrecognized argument");
      return "";
   }
}
