package pmp.io;

import pmp.InputSource;

/**
 * This class allows to place String into 
 * input queue list.
 * <p>Title: PMP: Macroprocessor</p>
 * <p>Description: Java macroprocessor</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class StringInputSource implements InputSource {

  private final String data;
  private int position;

  public String read(int maxLength)
  {
    int pos = this.position;
    int length = data.length() - pos;
    if (length > maxLength) {
      length = maxLength;
    } //if
    this.position += length;
    return data.substring(pos, this.position);
  }

  public void close()
  {
    // do nothing
  }

  public StringInputSource(CharSequence data)
  {
    this.data = data.toString();
    this.position = 0;
  }

} // StringInputSource
