package pmp.macro;

import pmp.*;

/**
 * Loads Java-class macro.
 * <p>The first parameter specifies name to be assigned to this macro;
 * the second parameter constains name of class.</p>
 * <p>Third parametre may contain name of Java class macro, which will be used
 * as output encoder for defined macro.</p>
 * <p>Title: PMP: Macroprocessor</p>
 * <p>Description: Java macroprocessor</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Builtin
    extends AbstractMacro {

  public static final int PARAMS_REQUIRED = 3;

  @Override
  public String run(Macroprocessor mp, String[] params)
  {
    String arg2 = params[2].trim();
    String arg3 = params[3].trim();

    AbstractMacro macro = mp.loadFromClass(arg2);

    if (macro == null) {
      return "";
    }

    if (!"".equals(arg3)) {
      AbstractMacro encoder = mp.loadFromClass(arg3);
      if (encoder != null) {
        macro = new MacroChain(macro, encoder);
      } //if
    } //if

    if (macro != null) {
      mp.getMPMacros().setMacro(params[1], macro);
    } //if

    return "";
  }

}
