package pmp.macro;

import pmp.*;

/**
 * Copies macro definition. The first parameter contains old name, the second is
 * new name.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Copydef extends AbstractMacro {
   // removed: If the third parameter is non-empty, definition stack is copied as well.
   // -- cannot be done since MacroList doesn't expose its MacroListItem objects

   public static final int PARAMS_REQUIRED = 3;

   @Override
   public String run(Macroprocessor mp, String[] args)
   {
      MacroList macros = mp.getMPMacros();

      if (args[3].length() == 0) { // shallow copy
         AbstractMacro orig = macros.getMacro(args[1]);
         macros.setMacro(args[2], orig);
      } else { // deep copy
         macros.copyMacro(args[1], args[2]);
      }

      return "";
   }

}
