package pmp.macro;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Returns definition of macro.
 * For user-defined it is substitution string, for builtin macros
 * it is result of {@link pmp.AbstractMacro#toString()}.
 * <p>Title: PMP: Macroprocessor</p>
 * <p>Description: Java macroprocessor</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Defn
    extends AbstractMacro {

  public static final int PARAMS_REQUIRED = 2;

  @Override
  public String run(Macroprocessor mp, String[] args)
  {
    AbstractMacro macro = mp.getMPMacros().getMacro(args[1]);

    if (macro != null) { 
      return macro.toString();
    }
    else {
      mp.warning("Macro doesn't exist: " + args[1]);
      return "";
    }

  }
}
