package pmp.macro;

import pmp.*;

/**
 * Includes file into input stream of macroprocessor.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Include extends AbstractMacro {

   public static final int PARAMS_REQUIRED = 1;

   @Override
   public String run(Macroprocessor mp, String[] args)
   {

      InputSource in = mp.getMPIO().getInput(args[1]);
      if (in == null) {
         mp.warning("Macro Include: Couldn't read from " + args[1]);
      } else {
         mp.getMPIQ().pushFront(in);
      }

      return "";
   }

}
