package pmp.macro;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/** 
 * Returns non empty string if exists macro with 
 * given name otherwise returns empty string.
 * <p>
 * If more than one parametr is given,
 * then second parametr is returned instead of<code>1</code>
 * and third parametr is returned otherwise
 * (provided the third parameter is specified).
 * </p>
 * 
 * <p>Title: PMP: Macroprocessor</p>
 * <p>Description: Java macroprocessor</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class IsSet
    extends AbstractMacro {

  public static final int PARAMS_REQUIRED = 1;

  @Override
  public String run(Macroprocessor mp, String[] params)
  {
     String yes = (params.length > 2) ? params[2]: "1";
     String no = (params.length > 3) ? params[3]: "";

     if (mp.getMPMacros().isDefined(params[1])) {
      return yes;
    }
    else {
      return no;
    }
  }

}
