package pmp.macro;

import pmp.*;

/** Removes definition of macro.
 * <p>Title: PMP: Macroprocessor</p>
 * <p>Description: Java macroprocessor</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Undefine
    extends AbstractMacro {

  public static final int PARAMS_REQUIRED = 1;

  @Override
  public String run(Macroprocessor mp, String[] args)
  {
    MacroList ml = mp.getMPMacros();

    if (ml.isDefined(args[1])) {
      ml.unsetMacro(args[1]);
    }
    else {
      mp.warning("Cannot undefine macro " + args[1]);
    }

    return "";
  }

}