package pmp.macro.java;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Class casting.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 * 
 */

public class Cast extends AbstractMacro {

    public static final int REQUIRED_PARAMS = 2;

    @Override
    public String run(Macroprocessor mp, String[] args)
    {
        ObjectManager mgr = ObjectManager.getInstance();
        String className = args[2].trim();
        try {
            int id = mgr.extractObjectId(args[1]);
            mgr.getObject(args[1]);
            Class<?> cl = Class.forName(className);
            Class<?> ocl = Class.forName(mgr.extractClassName(args[1]));
            if (cl.isAssignableFrom(ocl)) {
                StringBuilder result = new StringBuilder();
                result.append(cl.getName()).append(
                        ObjectManager.OBJ_ID_SEPARATOR).append(id);
                return result.toString();
            }
            else {
                mp.error("Macro Cast: Cannot cast " + args[1] + " to "
                        + className);
                return "";
            }

        } catch (ClassNotFoundException ex) {
            mp.error("Macro InstanceOf: Unknown class: " + className);
            return "";
        }
    }

}
