package pmp.macro.java;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Creates new Instance of String object with given contents. Returns object
 * identifier.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Luděk Hlaváček
 * @version 1.0
 * @see pmp.macro.java.New
 */
public class NewString extends AbstractMacro {

   public static final int PARAMS_REQUIRED = 1;

   @Override
   public java.lang.String run(Macroprocessor mp, java.lang.String[] args)
   {
      ObjectManager mgr = ObjectManager.getInstance();
      return mgr.addObject(args[1]);

   }

}
