package pmp.macro.java;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Returns class name of given object.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Luděk Hlaváček
 * @version 1.0
 * @see java.lang.Object#getClass()
 * @see java.lang.Class#getName()
 */

public class ToClassName extends AbstractMacro {

   @Override
   public String run(Macroprocessor mp, String[] args)
   {
      ObjectManager objmgr = ObjectManager.getInstance();
      try {
         objmgr.getObject(args[1]);
         final String expName = objmgr.extractClassName(args[1]);

         return expName;

      } catch (IllegalArgumentException ex) {
         mp.error("Macro ToClassName: Invalid identifier " + args[1]);
      } catch (IndexOutOfBoundsException ex) {
         mp.error("Macro ToClassName: Invalid identifier " + args[1]);
      }

      return "";
   }

}
