package pmp.macro.java;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Returns string representation of given object.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Luděk Hlaváček
 * @version 1.0
 * @see java.lang.Object#toString()
 */

public class ToString extends AbstractMacro {

   @Override
   public String run(Macroprocessor mp, String[] args)
   {
      final ObjectManager objmgr = ObjectManager.getInstance();
      try {
         Object obj = objmgr.getObject(args[1]);
         return obj.toString();

      } catch (IndexOutOfBoundsException ex) {
         mp.error("Macro InvokeStatic: invalid identifier " + args[1]);
      }

      return "";
   }

}
