package pmp.macro.lex;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Returns comma separated list of given parameters excluding the first.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Shift extends AbstractMacro {

   @Override
   public String run(Macroprocessor mp, String[] args)
   {
      if (args.length < 3) {
         return "";
      } // if

      else {
         StringBuilder result = new StringBuilder(64);
         result.append(Tools.convertToString(args[2]));
         for (int i = 3; i < args.length; i++)
            result.append(",").append(Tools.convertToString(args[i]));

         return result.toString();
      } // else
   }

}
