package pmp.macro.math;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Mathematical constants.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Const extends AbstractMacro {

    public static final int PARAMS_REQUIRED = 1;

    /** Returns value of &#x03C0;. */
    public static final String PI = "PI";

    /** Returns value of &#x03C0;&#x00B2;. */
    public static final String PI2 = "PI2";

    /** Returns natural log base. */
    public static final String E = "E";

    /** Returns Euler constant. */
    public static final String EULER = "EULER";

    /** Returns &#8730;2. */
    public static final String SQRT_2 = "SQRT_2";

    /** Returns &#8730;3. */
    public static final String SQRT_3 = "SQRT_3";

    /** Returns &#8730;&#x03C0;. */
    public static final String SQRT_PI = "SQRT_PI";

    /** Returns 1 / &#8730;2. */
    public static final String I_SQRT_2 = "I_SQRT_2";

    /** Returns 1 / &#8730;3. */
    public static final String I_SQRT_3 = "I_SQRT_3";

    /** Returns 1 / &#8730;&#x03C0;. */
    public static final String I_SQRT_PI = "I_SQRT_PI";

    /** Returns value of log<sub>2</sub>(e). */
    public static final String LOG2_E = "LOG2_E";

    /** Returns value of log<sub>10</sub>(e). */
    public static final String LOG10_E = "LOG10_E";

    /** Returns value of ln(2). */
    public static final String LN_2 = "LN_2";

    /** Returns value of ln(10). */
    public static final String LN_10 = "LN_10";

    /** Returns value of ln(&#x03C0;). */
    public static final String LN_PI = "LN_PI";

    @Override
    public String run(Macroprocessor mp, String[] args)
    {
        String c = args[1].trim().toUpperCase();

        if (PI.equals(c)) {
            return "3.14159265358979323846";
        }
        else if (PI2.equals(c)) {
            return "9.86960440108935861883";
        }
        else if (E.equals(c)) {
            return "2.7182818284590452354";
        }
        else if (EULER.equals(c)) {
            return "0.57721566490153286061";
        }

        else if (SQRT_2.equals(c)) {
            return "1.41421356237309504880";
        }
        else if (SQRT_3.equals(c)) {
            return "1.73205080756887729352";
        }
        else if (SQRT_PI.equals(c)) {
            return "1.77245385090551602730";
        }
        else if (I_SQRT_2.equals(c)) {
            return "0.70710678118654752440";
        }
        else if (I_SQRT_3.equals(c)) {
            return "0.57735026918962576451";
        }
        else if (I_SQRT_PI.equals(c)) {
            return "0.56418958354775628695";
        }

        else if (LOG2_E.equals(c)) {
            return "1.4426950408889634074";
        }
        else if (LOG10_E.equals(c)) {
            return "0.43429448190325182765";
        }

        else if (LN_2.equals(c)) {
            return "0.69314718055994530942";
        }
        else if (LN_PI.equals(c)) {
            return "1.14472988584940017414";
        }
        else if (LN_10.equals(c)) {
            return "2.30258509299404568402";
        }

        else {
            mp.warning("Macro Const: missing argument");
            return "";
        }
    }

}
