package pmp.macro.math;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Evaluates given expression and returns 
 * the second parameter if expression is not
 * zero. Otherwise the third parameter is returned.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 *
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */
public class IfNotZero extends AbstractMacro {

   private Eval eval = null;

   public static final int PARAMS_REQUIRED = 3;

   @Override
   public String run(Macroprocessor mp, String[] args)
   {
      if (eval == null)
         eval = new Eval();
      Number res;
      try {
         res = eval.parse(args[1]);
         if (Math.abs(res.doubleValue()) < 10*Math.ulp(res.doubleValue()))
            return args[3];
         else
            return args[2];

      } catch (IllegalArgumentException ex) {
         mp.warning("Macro IfNotZero: " + ex.getMessage());
      }
      return args[3];
   }

}
