package pmp.macro.math;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Returns given macro asinteger and incremented its content by one. If first
 * parameter is not valid integer number, <code>"1"</code> is returned.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Inc extends AbstractMacro {

    public static final int PARAMS_REQUIRED = 2;

    @Override
    public String run(Macroprocessor mp, String[] args)
    {

        long result = 0;
        AbstractMacro cntr = mp.getMPMacros().getMacro(args[1]);
        if (cntr != null) {
            try {
                result = Long.parseLong(cntr.toString());
            } catch (NumberFormatException ex) {
                mp.warning("Invalid argument in macro Inc");
                return "";
            }
        }
        long p2 = 1;
        try {
            p2 = Long.parseLong(args[2].trim());
        } catch (NumberFormatException ex) {
            // ignore
        }

        mp.getMPMacros().setMacro(args[1], Long.toString(result + p2));

        // return Long.toString(result);
        return "";
    }

}
