package pmp.macro.math;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Returns maximal value found among the parameters.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Max extends AbstractMacro {

    public static final int PARAMS_REQUIRED = 1;

    @Override
    public String run(Macroprocessor mp, String[] args)
    {
        if ((args.length == 2) && "".equals(args[1])) { // no parameter passed
            return "0";
        } // if

        long result = Long.MIN_VALUE;

        for (int i = 1; i < args.length; i++) {
            try {
                long j = Long.parseLong(args[i].trim());
                if (j > result) {
                    result = j;
                }
            } // try
            catch (NumberFormatException ex) {
                // invalid argument - do nothing about it
                mp.notice("Macro Max: invalid argument " + args[i]);
            } // catch

        } // for
        return Long.toString(result);

    }
}
