package pmp.macro.math;

import java.util.*;

/**
 * Tools for mathematical macros.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public final class Tools {

    private Tools()
    {
        // do not create instances
    }

    private static java.util.Random random;

    static java.util.Random getRandom()
    {
        if (random == null) {
            long seed = System.currentTimeMillis()
                    ^ ((new Object()).hashCode() << 32)
                    ^ Runtime.getRuntime().freeMemory();
            random = new java.util.Random(seed);
        }
        return random;
    }

    static final boolean isInt(String value)
    {
        if ((value == null) || "".equals(value)) { return false; }
        for (int i = 0; i < value.length(); i++) {
            if ((value.charAt(i) > '9') || (value.charAt(i) < '0')) { return false; }
        }
        return true;
    }

    /**
     * Removes all whitespace characters from string.
     * 
     * @param str
     *            string
     * @return input string with whitespaces removed
     */
    static final String removeSpaces(CharSequence str)
    {
        StringBuilder result = new StringBuilder(str.length());
        for (int i = 0; i < str.length(); i++) {
            char c = str.charAt(i);
            if (Arrays
                    .binarySearch(pmp.macro.str.Tools.getSpaceCharacters(), c) < 0) {
                result.append(c);
            }
        } // for
        return result.toString();
    }

}
