package pmp.macro.str;

import pmp.AbstractMacro;
import pmp.ConfigDirectives;
import pmp.Macroprocessor;

/** Macro for calculating Adler32 checksum.
 * <p>Title: PMP: Macroprocessor</p>
 * <p>Description: Java macroprocessor</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 * @todo was not tested !
 */

public class Adler32
    extends AbstractMacro {

  private java.util.zip.Adler32 engine;

  public Adler32()
  {
    engine = new java.util.zip.Adler32();
  }

  public static final int PARAMS_REQUIRED = 1;

  @Override
  public String run(Macroprocessor mp, String[] params)
  {
    String encoding = mp.getMPMacros().getStringL(
        ConfigDirectives.OUTPUT_ENCODING);

    byte[] str;
    if (params.length < 2) {
      str = new byte[0];
    }
    else {
      if ("".equals(encoding)) {
        str = params[1].getBytes();
      }
      else {
        try {
          str = params[1].getBytes(encoding);
        }
        catch (java.io.UnsupportedEncodingException ex) {
          mp.warning("Unsupported encoding" + encoding);
          str = params[1].getBytes();
        } //try/catch
      } //if/else
    } //if/else

    engine.reset();
    engine.update(str);
    int result = (int) engine.getValue();
    return Integer.toHexString(result).toUpperCase();
  }

}
