package pmp.macro.str;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Compare two strings. <b>Parameters:</b>
 * <ul>
 * <li><i>string1</i> - the first string</li>
 * <li><i>string2</i> - the second string</li>
 * <li><i>mode</i> - comparison mode flags: IGNORE_CASE</li>
 * </ul>
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Compare extends AbstractMacro {

    public static final int PARAMS_REQUIRED = 3;

    /** Value of the optional third parameter */ 
    public static final String IGNORE_CASE = "I";


    @Override
    public String run(Macroprocessor mp, String[] params)
    {
        if (params[3].toUpperCase().startsWith("I")) {
            if (params[1].equalsIgnoreCase(params[2])) {
                return "1";
            } 
        } else 
            if (params[1].equals(params[2])) {
                return "1";
            } 
        return "";
    }

}
