package pmp.macro.str;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Returns "1" if given parameter is integer number. Otherwise returns
 * <code>""</code>.
 * <p>
 * If more than one parametr is given, then second parametr is returned instead
 * of<code>1</code> and third parametr is returned otherwise (provided the
 * third parameter is specified).
 * </p>
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 * 
 */

public class IsNumber extends AbstractMacro {

    public static final int PARAMS_REQUIRED = 1;

    @Override
    public String run(Macroprocessor mp, String[] args)
    {
        String yes = (args.length > 2) ? args[2] : "1";
        String no = (args.length > 3) ? args[3] : "";

        try {
            Long.decode(args[1]);
            return yes;
        } catch (NumberFormatException ex) {
            // ignore
        }
        return no;
    }

}
