package pmp.macro.str;

import java.util.regex.*;

import pmp.AbstractMacro;
import pmp.Macroprocessor;
import pmp.RegExps;

/**
 * Returns "1" when string in first parameter
 * matches regular expression in second parameter.
 * Else returns empty string.
 * <p>Title: PMP: Macroprocessor</p>
 * <p>Description: Java macroprocessor</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Match
    extends AbstractMacro {

  public static final int PARAMS_REQUIRED = 2;

  @Override
  public String run(Macroprocessor mp, String[] params)
  {
    try {
      Pattern p = RegExps.compilePattern(params[2]);
      Matcher m = p.matcher(params[1]);

      if (m.matches()) {
        return "1";
      } //if

    } //try

    catch (PatternSyntaxException ex) {
      mp.warning("Invalid regular expression: " + params[2]);
    } //catch

    return "";
  }

}
