package pmp.macro.str;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Returns first parameter repeated number of times obtained from second
 * parameter.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Repeat extends AbstractMacro {

    public static final int PARAMS_REQUIRED = 2;

    @Override
    public String run(Macroprocessor mp, String[] args)
    {
        int count = 0;
        try {
            count = Integer.parseInt(args[2]);
        } catch (NumberFormatException ex) {
            if (args[2].length() > 0) {
                mp.warning("Repeat macro: invalid integer value.");
            } // if
        } // catch

        StringBuilder result = new StringBuilder(args[1].length() * count);

        for (int i = 0; i < count; i++) {
            result.append(args[1]);
        } // for

        return result.toString();
    }

}
