package pmp.macro.str;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import pmp.AbstractMacro;
import pmp.Macroprocessor;


/**
 * Replaces occurances of pattern (parameter 2)
 * in source text (parameter 1) with given
 * replacement (parametr 3).
 * 
 * <p>Title: PMP: Macroprocessor</p>
 * <p>Description: Java macroprocessor</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class Replace extends AbstractMacro {

    public static final int PARAMS_REQUIRED = 3;
    
    @Override
    public String run(Macroprocessor mp, String[] args)
    {
        Matcher m = Pattern.compile(args[2]).matcher(args[1]);
        return m.replaceAll(args[3]);
    }

}
