package pmp.macro.str;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Returns number of times string in the second parameter occurs in the first
 * parameter.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 */

public class SubstrCount extends AbstractMacro {

    public static final int PARAMS_REQUIRED = 2;

    @Override
    public String run(Macroprocessor mp, String[] args)
    {
        int i;
        int start = 0;
        int count = 0;

        if (args[2].length() == 0) { return "0"; }

        while ((i = args[1].indexOf(args[2], start)) != -1) {
            start = i + args[2].length();
            count++;
        } // while

        return Integer.toString(count);
    }

}
