package pmp.macro.str;

import java.util.*;

/**
 * <p>Title: PMP: Macroprocessor</p>
 * <p>Description: Java macroprocessor</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author Luděk Hlaváček
 * @version 1.0
 */

public final class Tools {
  private static char[] spaces;

  /**
   * Returns sorted array of whitespace characters.
   * @return array with space characters  
   */
  public static final char[] getSpaceCharacters()
  {
    if (spaces == null) {
      spaces = new char[] {
          ' ', // SPACE
          '\r', // CARRIAGE RETURN
          '\n', // LINE FEED
          '\t', // HORIZONTAL TABULATION
          '\f', // FORM FEED
//        '\b', // BACKSPACE
          '\0', // NULL
          '\u00A0', // NO-BREAK SPACE
          '\u0085', // NEXT LINE
          '\u200B', // Zero-width space
          '\u2028', // LINE SEPARATOR
          '\u2029' // PARAGRAPH SEPARATOR
      };
      Arrays.sort(spaces);

    }
    return spaces;
  }

}
