package pmp.macro.tools;

import pmp.AbstractMacro;
import pmp.Macroprocessor;

/**
 * Returns value of system property passed in first parameter. Default value
 * might be given in the second parameter.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 * @see java.lang.System#getProperty(java.lang.String)
 * @see java.lang.System#getProperty(java.lang.String, java.lang.String)
 */
public class GetProperty extends AbstractMacro {

    @Override
    public String run(Macroprocessor mp, String[] params)
    {
        if (params.length > 2) { 
            return System.getProperty(params[1], params[2]);
        }
        else if (params.length > 1) { 
            return System.getProperty(params[1]);
        }

        mp.warning("Macro Properties: Missing aruments");
        return "";
    }

}
