package pmp.macro.tools;

import pmp.*;

/**
 * Sets or clears system property passed in first parameter. If the second
 * parameter is specified, this value is set to given property, otherwise the
 * property is cleared.
 * <p>
 * Title: PMP: Macroprocessor
 * </p>
 * <p>
 * Description: Java macroprocessor
 * </p>
 * <p>
 * Copyright: Copyright (c) 2005
 * </p>
 * 
 * @author Lud\u011Bk Hlav\u00E1\u010Dek
 * @version 1.0
 * @see java.lang.System#setProperty(java.lang.String, java.lang.String)
 * @see java.lang.System#clearProperty(java.lang.String)
 */

public class SetProperty extends AbstractMacro {

    @Override
    public String run(Macroprocessor mp, String[] params)
    {
        if (params.length > 2) {
            System.setProperty(params[1], params[2]);
        }
        else if (params.length > 1) {
            System.clearProperty(params[1]);

        }
        else {
            mp.warning("Macro Properties: Missing aruments");
        }
        return "";
    }
}
